import Foundation
import metaoneSDK
import SwiftUI


class PromiseCallback<T> {
    let enqueueCallback: M1EnqueueCallback<T>
    init(resolve: @escaping RCTPromiseResolveBlock, reject: @escaping RCTPromiseRejectBlock) {
        self.enqueueCallback = M1EnqueueCallback(
            onSuccess: { response in
                if let encodableResponse = response as? Encodable {
                    let jsonString = Helper().stringify(data:encodableResponse)
                    resolve(Helper().toDictionary(text: jsonString!))
                } else if let simpleResponse = response as? String {
                    resolve(simpleResponse)
                } else if let simpleResponse = response as? Bool {
                    resolve(simpleResponse)
                } else if let simpleResponse = response as? Int {
                    resolve(simpleResponse)
                } else {
                    reject("ERROR_CODE", "Unable to convert response to dictionary", nil)
                }

            },
            onError: { error in
                print("onError-\(error)")
                reject(error.code, error.error, error.toError())
            }
        )
    }
}
